// xml.hh for raytance
//
// Started on  Sat Jul 27 04:10:30 2002
//  by Laurent CORBES {Caf'} caf@morkitu.com
// Last update Mon Sep 23 04:02:16 2002 alexandre chouippe
//  by Laurent CORBES {Caf'} caf@morkitu.com
// Short Comment: class for loading xml scenes

// Comment: 
// sont gere pour l'instant les materiaux, object: sphere cylinder box, lights
// les transformations aussi
// 

#ifndef _LOADANCE_XML_XML_HH_
#define _LOADANCE_XML_XML_HH_

#include <fstream>
#include <string>
#include "loadance/loading.hh"
#include "xml++.h"

namespace loadance 
{
  class LoadXml: public Loading
  {
  public:
    LoadXml (const std::string& file);
    virtual ~LoadXml () {};
    
    maintance::Scene* load ();
    void convert (std::ofstream&);
    
    std::string getFilename() const 
    { return _filename;};
  private:
 
    void treeRead (const XMLNode& node);
    void treeRead_C (const XMLNode& node);

    // affiche le contenue d'un noeud
    void nodeRead (const XMLNode& node);
    
    void makeEnvironment(const XMLNode& env);
    void makeMaterial (const XMLNode& mat);
    void makeSphere (const XMLNode& obj);
    void makeCylinder (const XMLNode& obj);
    void makeBox (const XMLNode& obj);
    void makePlane (const XMLNode& obj);
    void makeDisc (const XMLNode& obj);
    void makeOmni (const XMLNode& omni);
    void makeCamera (const XMLNode& cam);
    void makeText(const XMLNode& text);
    maintance::Transformer& makeTransformer (const XMLNode& obj);


    // fonctions for converting tool
    // attention c'est crade ne surtout pas regarder le code
    void makeEnvironment_C(const XMLNode& env);
    void makeMaterial_C (const XMLNode& mat);
    void makeSphere_C (const XMLNode& obj);
    void makeCylinder_C (const XMLNode& obj);
    void makeBox_C (const XMLNode& obj);
    void makePlane_C (const XMLNode& obj);
    void makeDisc_C (const XMLNode& obj);
    void makeOmni_C (const XMLNode& omni);
    void makeCamera_C (const XMLNode& cam);
    void makeTransformer_C (const XMLNode& obj);

    const std::string	_filename;
    XMLTree*		_tree;
    maintance::Scene*	_scene;
    std::ofstream*	_ostr;
    int			_ti;
    int			_ci;
  };
}

#endif //_LOADANCE_XML_HH_
