#ifndef _MAINTANCE_ANIMKEY_HH_
#define _MAINTANCE_ANIMKEY_HH_

#include "types.hh"
#include <cassert>
#include <vector>

namespace maintance
{
	template <typename T>
	class AnimKey {
	public :
		AnimKey(const T _elt, const float _frame) : 
				 elt(_elt), frame (_frame) {}


				 // Calcul la position courante dans une courbe a partir du tps
				 static void get_ih(unsigned int& index, 
					 float& h, 
					 std::vector<AnimKey<T>*>& curve,
					 float time)
				 {
					 assert(curve.size());
					 if (curve[index]->frame > time)
						 index = 0;
					 while (index + 1 < curve.size() && curve[index + 1]->frame <= time)
						 index++;
					 if (index + 1 == curve.size())
						 h = 0;
					 else
					 {
						 assert(curve[index]->frame != curve[index + 1]->frame); 
						 h = (time - curve[index]->frame) / (curve[index + 1]->frame - curve[index]->frame);
					 }
				 }

				 T elt;
				 float frame;
	};

	typedef AnimKey<types::Vect3df> VectKey;
}

#endif // _MAINTANCE_ANIMKEY_HH_
