//	box.hh
//
//	Henry PRECHEUR - E-mail: henry.precheur@epita.fr
//	last modification Time-stamp: <19-Jul-2002 01:24 by preche_h>

#ifndef	_BOX_HH_
#define	_BOX_HH_

#include "object.hh"

// la transformation ce fait par rapport a son centre
// les points sont exprimes par rapport au centre de la box
// un seul point est utile mais l'autre peut servir.

namespace maintance
{
	class Box: public Object
	{
	protected:
		types::Vect3df	_UpperLeftNear;
		types::Vect3df	_LowerRightFar;
	public:
		Box(Shader& shader, Transformer& trans, 
			types::Vect3df uln, types::Vect3df lrf);
		virtual ~Box() {}

		types::Vect3df	GetUpperLeftNear() const;
		types::Vect3df	GetLowerRightFar() const;
	public:
		void	print(std::ostream& os) const;
	};

	// inline fonct must be here :/
	inline types::Vect3df	Box::GetUpperLeftNear() const
	{ return _UpperLeftNear; }
	inline types::Vect3df	Box::GetLowerRightFar() const
	{ return _LowerRightFar; }
}

#endif // _BOX_HH_
