#include "camera.hh"

namespace maintance
{
  
  Camera::Camera(const std::string name, int kind)
  {
    _name = name;
    _fov = 45.0;
    _center.setx(0); _center.sety(0); _center.setz(-1);
    _target.setx(0); _target.sety(0); _target.setz(0);
    _kind = kind;
    _time = 0;
    }
  
  Camera::Camera(const std::string name, types::Vect3df center,
		 types::Vect3df target, 
		 float fov)
  {
    _name = name;
    _center = center;
    _target = target;
    _fov = fov;
  }

  void Camera::update()
  {
    _center_curve.finish();
    _target_curve.finish();
    _fov_curve.finish();
    _center = _center_curve.eval(_time);
    _target = _target_curve.eval(_time);
    _fov = _fov_curve.eval(_time);
  }
  
  void Camera::print(std::ostream& os) const
  {
    os << _name << ": " << _fov << ": " << _center << ": " << _target << std::endl;
  }
  
}
