#include "cylinder.hh"

namespace maintance
{
  Cylinder::Cylinder(Shader& shader, Transformer& trans,
		     types::Vect3df o, float height, float radius)
    : Object(CYLINDER, shader, trans), 
      _height(height), _radius(radius)
  {
    assert ((o.getNorm() == 1) && ((o.getx() + o.gety() + o.getz()) == 1));
    if (o.getx() == 1)
      _orientation = X_AXIS;
    if (o.gety() == 1)
      _orientation = Y_AXIS;
    if (o.getz() == 1)
      _orientation = Z_AXIS;
  }

  void Cylinder::print(std::ostream& os) const
  {
    os << "cylinder" << _ObjId << ": " 
       << "orientation=" << _orientation
       << " height=" << _height << " radius=" <<_radius << std::endl;
  }
}
