//	cylinder.hh
//
//	Henry PRECHEUR - E-mail: henry.precheur@epita.fr
//	last modification Time-stamp: <22-Sep-2002 22:11 by preche_h>

#ifndef	_CYLINDER_HH_
#define	_CYLINDER_HH_

#include "object.hh"

namespace maintance
{
	class Cylinder: public Object
	{
	public:
		enum	Orientation
		{
			X_AXIS,
			Y_AXIS,
			Z_AXIS
		};

	protected:
		Orientation	_orientation;
		float	_height;
		float	_radius;

	public:
		Cylinder(Shader& shader, Transformer& trans, 
			types::Vect3df o, float height, float radius);
		virtual ~Cylinder()
		{}
		float	GetHeight() const;
		float	GetRadius() const;
		Orientation	getOrient() const;

	public:
		void	print(std::ostream& os) const;
	};

	inline float	Cylinder::GetHeight() const
	{ return _height; }
	inline float	Cylinder::GetRadius() const
	{ return _radius; }
	inline Cylinder::Orientation	Cylinder::getOrient() const
	{
		return _orientation;
	}
}

#endif // _CYLINDER_HH_
