//	plane.hh
//
//	Henry PRECHEUR - E-mail: henry.precheur@epita.fr
//	last modification Time-stamp: <19-Jul-2002 10:43 by preche_h>

#ifndef	_DISC_HH_
#define	_DISC_HH_

#include "object.hh"

namespace maintance
{
	class Disc: public Object
	{
	protected:
		types::Vect3df	_normal;
		float		_radius;
	public:
		Disc(Shader& shader, Transformer& trans, 
			types::Vect3df p, float r);
		virtual ~Disc() {}

		const types::Vect3df&	getNormal() const;
		float			getRadius() const;
	public:
		void	print(std::ostream& os) const;
	};

	inline const types::Vect3df&	Disc::getNormal() const
	{ return _normal; }
	inline float			Disc::getRadius() const
	{ return _radius; }
}

#endif // _DISC_HH_
