// environment.hh for 
//
// Started on  Thu Sep 12 20:05:33 2002
//  by Laurent CORBES {Caf'} caf@morkitu.com
// Last update Sat Dec 14 13:12:17 2002
//  by Laurent CORBES {Caf'} caf@morkitu.com
// Short Comment: the env of the scene

#ifndef _ENVIRONMENT_HH_
#define _ENVIRONMENT_HH_

#include <iostream>
#include "color.hh"

namespace maintance
{
	class Environment
	{
	private:
		Color	_ambiant;
		Color	_sky_horizon;
		Color	_zenith;
		Color	_ground_horizon;
		Color	_ground;

	public:
		// default environment colors
		Environment()
			: _ambiant(), _sky_horizon(), _zenith(), _ground_horizon(), _ground()
		{}
		Environment(std::string am, 
			std::string skh, std::string ze, 
			std::string grh, std::string gr)
			: _ambiant(am), 
			_sky_horizon(skh), _zenith(ze), _ground_horizon(grh), _ground(gr)
		{}

		const Color& getAmbiant() const;
		const Color& getSkyHorizon() const;
		const Color& getZenith() const;
		const Color& getGroundHorizon() const;
		const Color& getGround() const;

		void print (std::ostream& os) const
		{
			os << "ambiant: " << _ambiant << std::endl
				<< "sky horizon " << _sky_horizon << std::endl
				<< "zenith " << _zenith << std::endl
				<< "ground horizon " << _ground_horizon << std::endl
				<< "ground " << _ground << std::endl;
		}
	};

	inline const Color& Environment::getAmbiant() const
	{ return _ambiant; }
	inline const Color& Environment::getSkyHorizon() const
	{ return _sky_horizon; }
	inline const Color& Environment::getZenith() const
	{ return _zenith; }
	inline const Color& Environment::getGroundHorizon() const
	{ return _ground_horizon; }
	inline const Color& Environment::getGround() const
	{ return _ground; }
};

#endif // _ENVIRONMENT_HH_
