//	light.hh
//
//	Henry PRECHEUR - E-mail: henry.precheur@epita.fr
//	last modification Time-stamp: <19-Jul-2002 16:52 by preche_h>

#ifndef	_LIGHT_HH_
#define	_LIGHT_HH_

#include <string>
#include <iostream>
#include "color.hh"
#include "transformer.hh"

namespace maintance
{
	// FIXME: for now there is only omni light and not complete
	class Light
	{
	protected:
		std::string		_Name;
		Transformer&	_trans;
		Color		_Color;

	public:
		Light(const std::string name, Transformer& trans, Color color);

		friend std::ostream& operator<<(std::ostream& ostr, 
			const Light& lig)
		{
			lig.print(ostr);
			return ostr;
		}
		void print(std::ostream& os) const;

		const Color&       	GetColor() const;
		const std::string&	GetName() const;
		const Transformer&	GetTransformer() const;

		void	SetTime(const float i)
		{ _trans.SetTime(i); }

	};

	inline const Color& Light::GetColor() const
	{ return _Color; }
	inline const std::string& Light::GetName() const
	{ return _Name; }
	inline const Transformer& Light::GetTransformer() const
	{ return _trans; }
}

#endif // _LIGHT_HH_
