//	object.hh
//
//	Henry PRECHEUR - E-mail: henry.precheur@epita.fr
//	last modification Time-stamp: <19-Sep-2002 17:01 by preche_h>

#ifndef	_OBJECT_HH_
#define	_OBJECT_HH_

#include <iostream>
#include "shader.hh"
#include "transformer.hh"
#include "types.hh"

// FIXME: a lot of things to add here ...
namespace maintance
{
	enum	ObjectType
	{
		SPHERE,
		CYLINDER,
		BOX,
		PLANE,
		DISC
	};

	class Object
	{
	protected:
		unsigned int	_ObjId;
		ObjectType	_Type;
		Shader*	_Shader;
		Transformer&	_transformer;

		Object(ObjectType type, Shader& shader, Transformer& trans);

	public:

		const Shader&	GetShader() const;
		const Transformer&	GetTransformer() const;
		void	SetTime(const float i);
		ObjectType	GetType() const;

		// printing way
	public:
		friend std::ostream& operator<<(std::ostream& ostr, 
			const Object& obj)
		{
			obj.print(ostr);
			return ostr;
		}
		virtual void	print(std::ostream& os) const = 0;
	};

	inline const Shader&	Object::GetShader() const
	{ return *_Shader; }
	inline const Transformer& Object::GetTransformer() const
	{ return _transformer; }

	inline ObjectType	Object::GetType() const
	{ return _Type; }

	inline void		Object::SetTime(const float i)
	{ _transformer.SetTime(i); }
}

#endif // _OBJECT_HH_
