#ifndef _MAINTANCE_POSITION_HH_
#define _MAINTANCE_POSITION_HH_

#include "types.hh"
#include <iostream>

// class position
// contient Trans + Scale + Rot
// Devrais bientot pouvoir etre convertit en matrice
// operateur << avec les stream


namespace maintance
{


	class Position {
	public :
		Position();

		Position(types::Vect3df trans,
			types::Vect3df scale);

	private:
		types::Vect3df _trans;
		types::Vect3df _scale;
		bool _modif;

	public:
		inline void SetTrans(types::Vect3df trans);
		inline void SetScale(types::Vect3df scale);

		inline const types::Vect3df& GetTrans() const;
		inline const types::Vect3df& GetScale() const;

		friend std::ostream& operator<<(std::ostream& ostr, 
			const Position& pos)
		{
			ostr << pos.GetTrans() << std::endl
				<< pos.GetScale() << std::endl;
			return ostr;
		}

	};

	inline void Position::SetTrans(types::Vect3df trans)
	{ _modif = true; _trans = trans;}
	inline void Position::SetScale(types::Vect3df scale)
	{ _modif = true; _scale = scale;}

	inline const types::Vect3df& Position::GetTrans() const
	{ return _trans;}
	inline const types::Vect3df& Position::GetScale() const
	{ return _scale;}

}

#endif // _MAINTANCE_POSITION_HH_
