#include "scene.hh"

namespace maintance
{
  void Scene::print(std::ostream& os) const
  {
    os << "---- environment ----" << std::endl;
    _env.print(os);
    os << "---- shader list ----" << std::endl;
    ShaderMap::const_iterator its;
    for (its = _shaderMap.begin(); its != _shaderMap.end(); ++its)
      (*its).second->print(os);
    os << "---- camera list ----" << std::endl;
    CameraMap::const_iterator itc;
    for (itc = _cameraMap.begin(); itc != _cameraMap.end(); ++itc)
      (*itc).second->print(os);
    os << "---- object list ----" << std::endl;
    ObjectList::const_iterator ito;
    for (ito = _objList.begin(); ito != _objList.end(); ++ito)
      (*ito)->print(os);
    os << "---- light list ----" << std::endl;
    LightList::const_iterator itl;
    for (itl = _lightList.begin(); itl != _lightList.end(); ++itl)
      (*itl)->print(os);
  }

  	void Scene::AddObject(Object& obj)
	{ _objList.push_back(&obj); }
	void Scene::AddLight(Light& light)
	{ _lightList.push_back(&light); }
	void Scene::AddShader(Shader& shader)
	{
		assert (_shaderMap.find(shader.getName()) == _shaderMap.end());
		_shaderMap[shader.getName()] = &shader;
	}
	void Scene::AddCamera(Camera& camera)
	{
		_cameraMap[camera.getName()] = &camera;
		_camera = &camera;
	}
}
