#include "font.hh"

GLuint base;

GLvoid BuildFont(HDC hDC, const char* fontname)
{
	HFONT	font;
	HFONT	oldfont;

	base = glGenLists(96);

	font = CreateFont(-24,
						0,
						0,
						0,
						FW_BOLD,
						FALSE,
						FALSE,
						FALSE,
						ANSI_CHARSET,
						OUT_TT_PRECIS,
						CLIP_DEFAULT_PRECIS,
						ANTIALIASED_QUALITY,
						FF_DONTCARE|DEFAULT_PITCH,
						fontname);

	oldfont = (HFONT)SelectObject(hDC, font);
	wglUseFontBitmaps(hDC, 32, 96, base);
	SelectObject(hDC, oldfont);
	DeleteObject(font);
}

GLvoid KillFont(GLvoid)
{
	glDeleteLists(base, 96);
}

GLvoid glFontPrint(const float x, const float y, const maintance::Color& color, const char *text)
{
//	glDisable(GL_DEPTH_TEST);	
	glPushAttrib(GL_LIST_BIT);
	glListBase(base - 32);

	// to avoid color problems -- big trick
	glRasterPos2f(-1000, -1000);
	glColor3f(color.GetColor()[0], color.GetColor()[1], color.GetColor()[2]);
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);
	// end of trick

//	glColor4f(1.f, 1.f, 1.f, 0.5f);
//	glBlendFunc(GL_SRC_COLOR, GL_DST_COLOR);
//	glEnable(GL_BLEND);
	glRasterPos2f(x, y);
	glColor3f(color.GetColor()[0], color.GetColor()[1], color.GetColor()[2]);
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);
//	glDisable(GL_BLEND);

	glPopAttrib();
//	glEnable(GL_DEPTH_TEST);
}

void	curverand(float curtime, const std::string& str, const types::Vect3df& disturbance, types::Vect3df& vec)
{
	static maintance::Color black(0.f, 0.f, 0.f);
	static maintance::Color grey(0.5f, 0.5f, 0.5f);
	static maintance::Color white(0.75f, 0.75f, 0.75f);
	glFontPrint(vec.getx() + disturbance.getx() * cos(curtime), vec.gety() + disturbance.gety() * sin(curtime) + rand() % 3, white, str.c_str());
	glFontPrint(vec.getx() + disturbance.getx() * cos(curtime) + rand() % 3, vec.gety() + 10 * sin(curtime), grey, str.c_str());
	glFontPrint(vec.getx(), vec.gety(), black, str.c_str());
}

/*
	//messages
	std::string ce("Cymagine & Epidemic");
	std::string pr("Presents");
	std::string sp("Synthesis Party 4");
	std::string da("february 20,21,22 2004");
	std::string pa("45Km from Paris");
	std::string url("http://wwww.synthesis-party.net/");
	std::string in("SP4-03:High ra(y)tance intro");
	std::string ct("Come TO or DIE");
	std::string pi("PiPiDemic RP");
*/