// Bumper for normal vector
//
// Started on  Monday Apr 1 01:30:00 2003
//  by Alex


#ifndef _RAYTRACE_WAVEBUMPER_HH_
#define _RAYTRACE_WAVEBUMPER_HH_

#include "types.hh"

namespace raytrace
{
  class BumperWave : public Bumper
  {

  public:
    BumperWave()
    {
    }

    virtual void perturb(const types::Vect3df& pt, types::Vect3df& norm)
    {
      static types::Vect3df res;
      float x;
      float cosa, sina;

      x = pt.getNorm() / 10.f;
      cosa = cos(x);
      sina = sin(x);
      
      res.setx(norm.getx());
      res.sety(norm.gety() * cosa + norm.getz() * sina);
      res.setz(norm.gety() * sina - norm.getz() * cosa);
      //norm = res;
      
    }
    
  };
}

#endif // _RAYTRACE_WAVEBUMPER_HH_
