// ray.hh for raytance
//
// Started on  Fri Aug 23 20:18:08 2002
//  by Laurent CORBES {Caf'} caf@morkitu.com
// Last update Fri Aug 30 04:50:43 2002
//  by Laurent CORBES {Caf'} caf@morkitu.com
// Short Comment: the ray 

#ifndef _RAYTRACE_RAY_HH_
#define _RAYTRACE_RAY_HH_

#include "types.hh"

namespace raytrace
{
  class Ray
  {
  public:

    Ray()
    {}

    Ray (const types::Vect3df& Pos, const types::Vect3df& Dest) 
      : pos(Pos), dest(Dest) {};
    
  public :
    types::Vect3df	pos;
    types::Vect3df	dest;
    
    
    inline types::Vect3df	Ray::getPos() const
    { return pos;};
    inline void		Ray::setPos(const types::Vect3df Pos)
    { pos = Pos;};
    inline const types::Vect3df&		Ray::getDest() const
    { return dest;};
    inline void		Ray::setDest(const types::Vect3df Dest)
    { dest = Dest;};
    void	print() const
    {
      std::cout << "o(" << pos.getx() << ", " << pos.gety() << ", "
		<< pos.getz() << "), d(" << dest.getx() << ", "
		<< dest.gety() << ", " << dest.getz() << ")" << std::endl;
    }
  };
  

}

#endif //_RAYTRACE_RAY_HH_
