#ifndef _MAINTANCE_SEQUENCER_SCENE_HH_
#define _MAINTANCE_SEQUENCER_SCENE_HH_

#include <iostream>
#include "sequencer.hh"
#include "maintance/base/scene.hh"
#include "maintance/raytrace/raytracer.hh"
#include "systance/frame_buffer.hh"


namespace maintance
{
	class SceneSequencer: public Sequencer
{
public:
	SceneSequencer(maintance::Scene& scene, systance::FrameBuffer* fb): 
		_scene(scene), _fb(fb),
		_rayt(scene, fb->GetWidth(), fb->GetHeight())
	{
		_initdone = false;
		_fb->Attach(_rayt);
	};

	~SceneSequencer()
	{
	};

	void Draw (float time)
	{
//		std::cout << "Draw scene" << std::endl;
		if (!_initdone)
		{
			_fb->Attach(_rayt);
			_initdone = true;
		}
		if (_curve)
		{
//			std::cout << time << "--" << _curve->eval(time) << std::endl;
			_scene.SetTime(_curve->eval(time));
		}
		else
			_scene.SetTime(time);

		_rayt.Update();
		_fb->Trace();
	};

private:
	maintance::Scene&	_scene;
	raytrace::Raytracer	_rayt;
	systance::FrameBuffer*	_fb;
	bool				_initdone;
};

};

#endif _MAINTANCE_SEQUENCER_SCENE_HH_