#ifndef _MAINTANCE_SEQUENCER_HH_
#define _MAINTANCE_SEQUENCER_HH_

#include <vector>
#include "toolance/curve.hh"

namespace maintance
{
	class Sequencer;
	typedef std::vector<Sequencer*> Sequencerlist;

class Sequencer
{
public:
	Sequencer()
	{
		_curve = NULL;
	};

	~Sequencer()
	{
		for (Sequencerlist::iterator i = _children.begin(); i != _children.end(); ++i)
			delete *i;
	};

	virtual void Draw(float time)
	{
		for (Sequencerlist::const_iterator i = _children.begin(); i != _children.end(); ++i)
		{	
//			std::cout << "hello sequencer child" << std::endl;			
			if (_curve)
				(*i)->Draw(_curve->eval(time));
			else
				(*i)->Draw(time);
		}
	};

	void AddChild (Sequencer &child)
	{
		_children.push_back(&child);
	};

	void SetCurve (types::Curve<float> &curve)
	{
		_curve = &curve;
	};

protected:
	Sequencerlist	_children;
	types::Curve<float>*	_curve;
};

};

#endif _MAINTANCE_SEQUENCER_HH_