//	time.cc
//
//	Henry PRECHEUR - E-mail: henry.precheur@epita.fr
//	last modification Time-stamp: <08-May-2003 19:54:21 caf>

#include "time.hh"

namespace systance
{
  Time::Time()
  {
    _Time = _TimeStart = 0;
#ifdef UNIX
    _Tv.tv_sec = _Tv.tv_usec = 0;
#endif
    _Locked = true;
  }

  void	Time::Init()
  {
#ifdef UNIX   
    if (gettimeofday(&_Tv, 0) != 0)
      std::cerr << "Error: unable to handle timer!" << std::endl;
    _TimeStart = double(_Tv.tv_sec + (_Tv.tv_usec / 1000000.0f));
#else
		LARGE_INTEGER frequency;
		LARGE_INTEGER ticks;

		if (!QueryPerformanceFrequency(&frequency))
			std::cerr << "Performance timer not supported" << std::endl;
		_frequency = frequency.QuadPart;
		QueryPerformanceCounter(&ticks);	
		_TimeStart = ticks.QuadPart / _frequency;
#endif
    _Time = _TimeStart;
    _Locked = false;
  }
}
