//	window.hh
//
//	Henry PRECHEUR - E-mail: henry.precheur@epita.fr
//	last modification Time-stamp: <27-Oct-2003 23:00:54 lcaf>

#ifndef	_WINDOW_HH_
#define	_WINDOW_HH_

#include <windows.h>								// Header File For Windows
#include <GL\gl.h>								// Header File For The OpenGL32 Library
//#include <GL\glu.h>								// Header File For The GLu32 Library
//#include <GL\glaux.h>								// Header File For The GLaux Library

// Comment: 
// The unix window
// it's the rendering window in GL of raytance
// the Draw method get the current frame buffer and display it
//

// Comment: 
// Init SDL/GL avec gestion evenements via sdl
//

namespace systance
{

  class UnixWindow
  {
  private:
    int		_Width;
    int		_Height;
    int		_Bpp;
    bool	_Fullscreen;
    bool	_Quit;
    
	HGLRC           hRC;							// Permanent Rendering Context
								// Private GDI Device Context
	HWND            hWnd;							// Holds Our Window Handle
	HINSTANCE       hInstance;							// Holds The Instance Of The Application

	MSG		msg;									// Windows Message Structure


  public:
    UnixWindow(void);
    bool	Create(int witdh, int height, int bpp, bool fullscreen);
    void	Draw();
    void	Destroy(void);
    bool	IsQuit(void);
//    void	SetWindowTitle(char* window_name);

	int	GetWidth() const;
    int	GetHeight() const;
		HDC             hDC;

  };
  
  inline bool	UnixWindow::IsQuit(void)
  {
    return (_Quit);
  }


}

#endif // _WINDOW_HH_
