//
// euler.hh for  in 
// 
// Made by Laurent CORBES {Caf'}
// Login   <corbes_l@epita.fr>
// 
// Started on  Fri Feb 15 03:40:39 2002 Laurent CORBES {Caf'}
// Last update Thu Aug 29 00:22:41 2002
//

#ifndef _TYPES_EULER_HH_
#define _TYPES_EULER_HH_

#include "streamable.hh"

namespace types
{
	template <typename T>
	class Vect3d;
	template <typename T>
	class Quaternion;

	template <typename T>
	class Euler: public Streamable
	{
	public:
		Euler()
		{_v.setx(0); _v.sety(0); _v.setz(0);};
		Euler(const float x, const float y, const float z)
		{_v.setx(x); _v.sety(y); _v.setz(z);};
		virtual ~Euler() {};

		virtual void print(std::ostream& os) const
		{
			os << _v.getx() << " " << _v.gety() << " " << _v.getz() << std::endl;
		}
		virtual void read(std::istream& is)
		{
			float	x, y, z;

			is >> x >> y >> z;
			_v.setx(x); _v.sety(y); _v.setz(z);
		}

		Vect3d<T> getv() const {return _v;};
	private:
		Vect3d<T> _v;
	};
}

#endif // EULER_HH
