// Tiny STL Vector par Alex
// Ne fait que de l'ajout
// append
// operator []
// getbuffer

#ifndef __RT_VECTOR__
#define __RT_VECTOR__

#include <cassert>

#define DEFAULT_RTVECTOR_SIZE		50
#define RTVECTOR_REALLOC_OFFSET		25

namespace types
{

	template <typename T>
	class RtVector
	{
	public :
		//--------------------------------------------------
		RtVector(unsigned int size = DEFAULT_RTVECTOR_SIZE) 
			: _allocated(size), _nb_elt(0)
		{
			_data = new T[_allocated];
		}

		//--------------------------------------------------
		~RtVector()
		{ 
			delete _data;
		}

		//--------------------------------------------------
		inline int push_back(T elt)
		{
			if (_nb_elt < _allocated)
				_data[_nb_elt] = elt;
			else
			{
				_allocated += RTVECTOR_REALLOC_OFFSET;
				realloc(_allocated);
				_data[_nb_elt] = elt;
			}
			return ++_nb_elt;
		}


		//--------------------------------------------------
		inline T& operator[](const int i)
		{
//			assert(i < _nb_elt);
			return ( (i < _nb_elt) ? _data[i]: _data[_nb_elt - 1] );
		}

		//--------------------------------------------------
		inline unsigned int size() const
		{
			return _nb_elt;
		}
	private :

		void realloc(unsigned int size)
		{
			T* tmp = new T[size];

			for(unsigned int i = 0; i < _nb_elt; i++)
			{
				tmp[i] = _data[i];
			}
			delete _data;
			_data = tmp;

		}

		unsigned int	_allocated;
		unsigned int	_nb_elt;

		T*		_data;
	};

}




#endif // __RT_VECTOR__
