#ifndef TYPES_STREAMABLE_HH
#define TYPES_STREAMABLE_HH

#include <iostream>

namespace types 
{
  class Streamable
  {
  public:
    virtual void print(std::ostream& os)const = 0;
    virtual void read(std::istream& is) = 0;
    friend std::ostream& operator<<(std::ostream& ostr, 
				    const Streamable& stream)
    {
      stream.print(ostr);
      return ostr;
    }
    friend std::istream& operator>>(std::istream& istr, 
				    Streamable& stream)
    {
      stream.read(istr);
      return istr;
    }
  };
}
#endif // TYPES_STREAMABLE_HH
